Index: trunk/FACT++/configure
===================================================================
--- trunk/FACT++/configure	(revision 12756)
+++ trunk/FACT++/configure	(revision 12768)
@@ -4622,5 +4622,5 @@
   { $as_echo "$as_me:${as_lineno-$LINENO}: checking if g++ supports C++0x features without additional flags" >&5
 $as_echo_n "checking if g++ supports C++0x features without additional flags... " >&6; }
-if test "${ac_cv_cxx_compile_cxx0x_native+set}" = set; then :
+if test "${ax_cv_cxx_compile_cxx0x_native+set}" = set; then :
   $as_echo_n "(cached) " >&6
 else
@@ -4648,5 +4648,5 @@
     typedef check<int> check_type;
     check_type c;
-    check_type&& cr = c;
+    check_type&& cr = static_cast<check_type&&>(c);
 int
 main ()
@@ -4658,7 +4658,7 @@
 _ACEOF
 if ac_fn_cxx_try_compile "$LINENO"; then :
-  ac_cv_cxx_compile_cxx0x_native=yes
-else
-  ac_cv_cxx_compile_cxx0x_native=no
+  ax_cv_cxx_compile_cxx0x_native=yes
+else
+  ax_cv_cxx_compile_cxx0x_native=no
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.$ac_ext
@@ -4671,10 +4671,10 @@
 
 fi
-{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $ac_cv_cxx_compile_cxx0x_native" >&5
-$as_echo "$ac_cv_cxx_compile_cxx0x_native" >&6; }
+{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $ax_cv_cxx_compile_cxx0x_native" >&5
+$as_echo "$ax_cv_cxx_compile_cxx0x_native" >&6; }
 
   { $as_echo "$as_me:${as_lineno-$LINENO}: checking if g++ supports C++0x features with -std=c++0x" >&5
 $as_echo_n "checking if g++ supports C++0x features with -std=c++0x... " >&6; }
-if test "${ac_cv_cxx_compile_cxx0x_cxx+set}" = set; then :
+if test "${ax_cv_cxx_compile_cxx0x_cxx+set}" = set; then :
   $as_echo_n "(cached) " >&6
 else
@@ -4704,5 +4704,5 @@
     typedef check<int> check_type;
     check_type c;
-    check_type&& cr = c;
+    check_type&& cr = static_cast<check_type&&>(c);
 int
 main ()
@@ -4714,7 +4714,7 @@
 _ACEOF
 if ac_fn_cxx_try_compile "$LINENO"; then :
-  ac_cv_cxx_compile_cxx0x_cxx=yes
-else
-  ac_cv_cxx_compile_cxx0x_cxx=no
+  ax_cv_cxx_compile_cxx0x_cxx=yes
+else
+  ax_cv_cxx_compile_cxx0x_cxx=no
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.$ac_ext
@@ -4728,10 +4728,10 @@
 
 fi
-{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $ac_cv_cxx_compile_cxx0x_cxx" >&5
-$as_echo "$ac_cv_cxx_compile_cxx0x_cxx" >&6; }
+{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $ax_cv_cxx_compile_cxx0x_cxx" >&5
+$as_echo "$ax_cv_cxx_compile_cxx0x_cxx" >&6; }
 
   { $as_echo "$as_me:${as_lineno-$LINENO}: checking if g++ supports C++0x features with -std=gnu++0x" >&5
 $as_echo_n "checking if g++ supports C++0x features with -std=gnu++0x... " >&6; }
-if test "${ac_cv_cxx_compile_cxx0x_gxx+set}" = set; then :
+if test "${ax_cv_cxx_compile_cxx0x_gxx+set}" = set; then :
   $as_echo_n "(cached) " >&6
 else
@@ -4761,5 +4761,5 @@
     typedef check<int> check_type;
     check_type c;
-    check_type&& cr = c;
+    check_type&& cr = static_cast<check_type&&>(c);
 int
 main ()
@@ -4771,7 +4771,7 @@
 _ACEOF
 if ac_fn_cxx_try_compile "$LINENO"; then :
-  ac_cv_cxx_compile_cxx0x_gxx=yes
-else
-  ac_cv_cxx_compile_cxx0x_gxx=no
+  ax_cv_cxx_compile_cxx0x_gxx=yes
+else
+  ax_cv_cxx_compile_cxx0x_gxx=no
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.$ac_ext
@@ -4785,10 +4785,10 @@
 
 fi
-{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $ac_cv_cxx_compile_cxx0x_gxx" >&5
-$as_echo "$ac_cv_cxx_compile_cxx0x_gxx" >&6; }
-
-  if test "$ac_cv_cxx_compile_cxx0x_native" = yes ||
-     test "$ac_cv_cxx_compile_cxx0x_cxx" = yes ||
-     test "$ac_cv_cxx_compile_cxx0x_gxx" = yes; then
+{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $ax_cv_cxx_compile_cxx0x_gxx" >&5
+$as_echo "$ax_cv_cxx_compile_cxx0x_gxx" >&6; }
+
+  if test "$ax_cv_cxx_compile_cxx0x_native" = yes ||
+     test "$ax_cv_cxx_compile_cxx0x_cxx" = yes ||
+     test "$ax_cv_cxx_compile_cxx0x_gxx" = yes; then
 
 $as_echo "#define HAVE_STDCXX_0X /**/" >>confdefs.h
@@ -4796,5 +4796,5 @@
   fi
 
-if test "$ac_cv_cxx_compile_cxx0x_cxx" != yes; then
+if test "$ax_cv_cxx_compile_cxx0x_cxx" != yes; then
    as_fn_error $? "C++0x standard (-std=c++0x) not supported by compiler." "$LINENO" 5
 fi